//+------------------------------------------------------------------+
//|                                                  Strategy #4.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""
#property indicator_chart_window
#property indicator_buffers 2
#property strict

#property indicator_color1 DeepSkyBlue      
#property indicator_color2 DeepPink        
#property indicator_width1 1  
#property indicator_width2 1  

extern int Length = 15;
extern bool  alertsOn          = false;        // Turn alerts on?
extern bool  alertsOnCurrent   = true;         // Alerts on current (still opened) bar?
extern bool  alertsMessage     = true;         // Alerts should display a message?
extern bool  alertsSound       = false;        // Alerts should play a sound?
extern bool  alertsEmail       = false;        // Alerts should send an email?
extern bool  alertsPush        = true;         // Alerts should send notification?

extern int ArrowDistance = 1;

double Up_Arrow_Buffer[];    
double Down_Arrow_Buffer[];  




//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
{
   
   SetIndexStyle(0, DRAW_ARROW);
   SetIndexBuffer(0, Up_Arrow_Buffer);
   SetIndexArrow(0, 225); 
   SetIndexStyle(1, DRAW_ARROW);
   SetIndexBuffer(1, Down_Arrow_Buffer);
   SetIndexArrow(1, 226); 
   
//----
   return(0);
  }
  
  
  
  
  
  
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }
  
  
  
  
  
  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
   
   for (int i=limit; i>=0; i-- ) 
   {
      Up_Arrow_Buffer[i]   = EMPTY_VALUE;
      Down_Arrow_Buffer[i] = EMPTY_VALUE;
      if (Close[i]<(High[i]-(High[i]-Low[i])*75/100) && (High[i]>=High[ArrayMaximum(High,5,i)] || High[i+1]>=High[ArrayMaximum(High,5,i)]) && Close[i]<iMA(NULL,0,50,0,MODE_SMA,0,i))
            Down_Arrow_Buffer[i] = High[i] + (ArrowDistance * Point);
      if (Close[i]>((High[i]-Low[i])*75/100+Low[i]) && (Low[i]<=Low[ArrayMinimum(Low,5,i)] || Low[i+1]<=Low[ArrayMinimum(Low,5,i)]) && Close[i]>iMA(NULL,0,50,0,MODE_SMA,0,i))
            Up_Arrow_Buffer[i] = Low[i] - (ArrowDistance * Point);
   }
   manageAlerts();
   return(0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts() 
{
   if (alertsOn) 
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
         if (Up_Arrow_Buffer[whichBar]   !=  EMPTY_VALUE) doAlert(whichBar," up");
         if (Down_Arrow_Buffer[whichBar] !=  EMPTY_VALUE) doAlert(whichBar," down");
   }      
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message = timeFrameToString(_Period)+" "+_Symbol+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" strategy signal "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," strategy "),message);
          if (alertsPush)    SendNotification(message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}
